import numpy as np
import tensorflow as tf


def f2uint(x):
    if x.__class__ == tf.Tensor:
        return tf.cast(tf.clip_by_value((x+1)*127.5, 0, 255), tf.uint8)
    else:
        return np.clip((x+1)*127.5, 0, 255).astype(np.uint8)


def generate_mask_rect(im_shapes, mask_shapes, rand=True):
    mask = np.zeros((im_shapes[0], im_shapes[1])).astype(np.float32)
    if rand:
        of0 = np.random.randint(0, im_shapes[0]-mask_shapes[0])
        of1 = np.random.randint(0, im_shapes[1]-mask_shapes[1])
    else:
        of0 = (im_shapes[0]-mask_shapes[0])//2
        of1 = (im_shapes[1]-mask_shapes[1])//2
    mask[of0:of0+mask_shapes[0], of1:of1+mask_shapes[1]] = 1
    mask = np.expand_dims(mask, axis=2)
    return mask


